float4x4 WorldMatrix : WORLD;
float4x4 ViewProjMatrix : VIEWPROJECTION;

float4x4 m;
float4x4 WorldViewProjMatrix;

struct VS_INPUT
{
    float4 Pos        : POSITION;
    float2 Tex        : TEXCOORD0;
    float4 Col        : COLOR0;
    
};


struct VS_OUTPUT
{
    float4 Pos        : POSITION;
    float2 Tex        : TEXCOORD0;
    float4 Col        : COLOR0;
    
};

VS_OUTPUT XShadow_VS(VS_INPUT In)
{
	VS_OUTPUT Out;
	
	float height		= 0.05;		//e̍
	float scale			= 10.0;		//ȇ傫
	float max_height	= 10.0;		//ڑ{[̊
	float adjust		= 0.2;		//e̔Zl

	//reset rotate
	m._11 = scale;
	m._22 = scale;
	m._33 = scale;
	m._44 = 1.0;
	m._41 = WorldMatrix._41;
	m._42 = height;
	m._43 = WorldMatrix._43;

	WorldViewProjMatrix = mul(m, ViewProjMatrix);

	Out.Pos = mul( In.Pos, WorldViewProjMatrix );
	Out.Tex = In.Tex;
	Out.Col = In.Col;
	
	//ajust aplha
	float alpha;
	float bone_height;
	bone_height = WorldMatrix._42;
	
	if(bone_height < 0)
		alpha = 0;
	if(bone_height >= max_height)
		alpha = max(bone_height, max_height);
	
	Out.Col.w = 1.0 - (bone_height*adjust);

	return Out;
}

technique MainTec < string MMDPass = "object"; > {
	pass DrawObject
	{
		VertexShader = compile vs_2_0 XShadow_VS();
		//PixelShader  = compile ps_2_0 XShadow_PS();
	}
}

